'''
1. В директории проекта создать каталог log, в котором для клиентской и серверной сторон в отдельных модулях формата client_log_config.py и server_log_config.py создать логгеры;
2. В каждом модуле выполнить настройку соответствующего логгера по следующему алгоритму:
a. Создание именованного логгера;
b. Сообщения лога должны иметь следующий формат: "<дата-время> <уровеньважности> <имямодуля> <сообщение>";
c. Журналирование должно производиться в лог-файл;
d. На стороне сервера необходимо настроить ежедневную ротацию лог-файлов.
3. Реализовать применение созданных логгеров для решения двух задач:
a. Журналирование обработки исключений try/except. Вместо функции print() использовать журналирование и обеспечить вывод служебных сообщений в лог-файл;
b. Журналирование функций, исполняемых на серверной и клиентской сторонах при работе мессенджера.
'''

import logging
import logging.handlers
import sys
import os

logging.basicConfig(
    handlers=[
        logging.handlers.TimedRotatingFileHandler(
            'server.log',
            when='d',
            encoding='UTF-8'),
        logging.StreamHandler(
            stream=sys.stdout)],
    format='%(asctime)s %(levelname)s %(message)s',
    level=logging.INFO
)
log = logging.getLogger('server_log')


if __name__ == '__main__':
    pass
